unit courbes2d_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, StdCtrls,
  Math;

type

  { TWdMain }

  TWdMain = class(TForm)
    Img1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Pa0: TPanel;
    Pa1: TPanel;
    Pa2: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton18: TSpeedButton;
    SpeedButton19: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton20: TSpeedButton;
    SpeedButton21: TSpeedButton;
    SpeedButton22: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure SpeedButton14Click(Sender: TObject);
    procedure SpeedButton15Click(Sender: TObject);
    procedure SpeedButton16Click(Sender: TObject);
    procedure SpeedButton17Click(Sender: TObject);
    procedure SpeedButton18Click(Sender: TObject);
    procedure SpeedButton19Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton20Click(Sender: TObject);
    procedure SpeedButton21Click(Sender: TObject);
    procedure SpeedButton22Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdMain: TWdMain;

implementation

{$R *.lfm}

{ TWdMain }

var
  MaxX, MaxY: integer;
  CentreX, CentreY, CentreZ: integer;
  Zoom: integer;

procedure Img_max;
begin
  with WdMain.Img1 do
  begin
    MaxX := Width - 1;
    MaxY := Height - 1;
    CentreX := MaxX div 2;
    CentreY := MaxY div 2;
    CentreZ := MaxX div 2;
  end;
end;

procedure Img_Clear;
var
  x: integer;
begin
  with WdMain.Img1.Canvas do
  begin
    Pen.Color := ClCream;
    for x := 0 to MaxX do
      Line(x, 0, x, MaxY);
  end;
end;

procedure Img_Courbe_Carthesienne(Select: integer);
var
  t: real;
  Rx, Ry: real;
  Fin: real;
  x, y: integer;
begin
  Img_Max;
  Img_Clear;
  with WdMain.Img1.Canvas do
  begin
    Pen.Color := ClBlack;
    case Select of
      1:
      begin
        Zoom := 120;
        Fin := 2 * Pi;
      end;
      2:
      begin
        Zoom := 200;
        Fin := 2 * Pi;
      end;
      3:
      begin
        Zoom := 200;
        Fin := 2 * Pi;
      end;
      4:
      begin
        Zoom := 200;
        Fin := 2 * Pi;
      end;
      5:
      begin
        Zoom := 200;
        Fin := 2 * Pi;
      end;
      6:
      begin
        Zoom := 120;
        Fin := 2 * Pi;
      end;
      7:
      begin
        Zoom := 60;
        Fin := 2 * Pi;
      end;
      8:
      begin
        Zoom := 120;
        Fin := 2 * Pi;
      end;
      9:
      begin
        Zoom := 80;
        Fin := 2 * Pi;
      end;
      10:
      begin
        Zoom := 90;
        Fin := 2 * Pi;
      end;
      11:
      begin
        Zoom := 250;
        Fin := 2 * Pi;
      end;
      12:
      begin
        Zoom := 100;
        Fin := 2 * Pi;
      end;
    end;
    t := 0;
    repeat
      Rx := 0;
      Ry := 0;
      case Select of
        1:
        begin
          Rx := sin(4 * t) + cos(t);
          Ry := cos(2 * t) + sin(3 * t);
        end;
        2:
        begin
          Rx := sin(2 * t);
          Ry := sin(t + sin(2 * t));
        end;
        3:
        begin
          Rx := cos(t);
          Ry := sin(t + sin(5 * t));
        end;
        4:
        begin
          Rx := sin(2 * t);
          Ry := sin(t + cos(5 * t));
        end;
        5:
        begin
          Rx := cos(5 * t);
          Ry := sin(t + cos(5 * t));
        end;
        6:
        begin
          Rx := cos(3 * t) + sin(5 * t);
          Ry := sin(2 * t) + cos(6 * t);
        end;
        7:
        begin
          Rx := cos(5 * t) + (4 * sin(t));
          Ry := cos(3 * t) + 2 * sin(5 * t);
        end;
        8:
        begin
          Rx := sin(10 * t) + cos(5 * t);
          Ry := cos(2 * t) + sin(5 * t);
        end;
        9:
        begin
          Rx := (2 - sin(7 * t) - 0.5 * cos(30 * t)) * cos(t);
          Ry := (2 - sin(7 * t) - 0.5 * cos(30 * t)) * sin(t);
        end;
        10:
        begin
          Rx := 2.5 * sin(t) - sin(20 * t);
          Ry := cos(t) - cos(40 * t) * sin(t);
        end;
        11:
        begin
          Rx := Sin(t + Cos(100 * t));
          Ry := Cos(t + Sin(100 * t));
        end;
        12:
        begin
          Rx := 2 * sin(t) - sin(80 * t);
          Ry := cos(t) - cos(80 * t) * sin(t);
        end;
      end;
      x := Round(CentreX + Zoom * Rx);
      y := Round(CentreX + Zoom * Ry);
      Pixels[x, y] := ClBlack;
      t := t + 0.0001;
    until t > Fin;
  end;
end;

procedure Img_Courbe_Polaire(Select: integer);
var
  Fin, r, t, t2: real;
  x, y, m, n: integer;
begin
  Img_Max;
  Img_Clear;
  with WdMain.Img1.Canvas do
  begin
    Pen.Color := ClBlack;
    r := 0;
    x := 0;
    y := 0;
    Fin := 2 * Pi;
    case Select of
      1:
      begin
        Fin := 2 * Pi;
        Zoom := 40;
      end;
      2:
      begin
        Fin := 4 * Pi;
        Zoom := 240;
      end;
      3:
      begin
        Fin := 2 * Pi;
        Zoom := 50;
      end;
      4:
      begin
        Fin := 10 * Pi;
        Zoom := 160;
      end;
      5:
      begin
        Fin := 8 * Pi;
        Zoom := 170;
      end;
      6:
      begin
        Fin := 10 * Pi;
        Zoom := 40;
      end;
      7:
      begin
        Fin := 10 * Pi;
        Zoom := 90;
      end;
      8:
      begin
        Fin := 20 * Pi;
        Zoom := 280;
      end;
      9:
      begin
        Fin := 10 * Pi;
        Zoom := 8;
        n := 4;
      end;
    end;
    t := 0.0001;
    repeat
      case Select of
        1:
        begin
          r := 7 * sin(3 * t);
        end;
        2:
        begin
          r := 1 / 4 + cos(7 * t / 2);
        end;
        3:
        begin
          r := (3 * sin(t) + 3.5 * cos(12 * t) * cos(10 * t)) * -1;
        end;
        4:
        begin
          t2 := sin(9 * t) - cos(6 * t);
          r := sin(4 * t2) + cos(t2);
        end;
        5:
        begin
          r := Sqr(cos(1.4 * t)) + Power(sin(5 * 1.4 * t), 3);
        end;
        6:
        begin
          r := 7 * (sin(t) / t);
        end;
        7:
        begin
          r := 2 + sin(3 * t / 5);
        end;
        8:
        begin
          r := cos(9 * t / 10);
        end;
        9:
        begin
          m := 2 * (n - 1);
          r := 6 / (sin(m * t));
          if (t > 2 * Pi) or (t > 4 * Pi) or (t > 6 * Pi) or (t > 8 * Pi) then
            Inc(n);
        end;
      end;
      x := Round(CentreX + Zoom * r * cos(t));
      y := Round(CentreY + Zoom * r * sin(t));
      Pixels[x, y] := ClBlack;
      t := t + 0.001;
    until t > Fin;
  end;
end;

procedure TWdMain.SpeedButton1Click(Sender: TObject);
begin
  Img_Courbe_Carthesienne(1);
end;

procedure TWdMain.SpeedButton2Click(Sender: TObject);
begin
  Img_Courbe_Carthesienne(2);
end;

procedure TWdMain.SpeedButton3Click(Sender: TObject);
begin
  Img_Courbe_Carthesienne(3);
end;

procedure TWdMain.SpeedButton4Click(Sender: TObject);
begin
  Img_Courbe_Carthesienne(4);
end;

procedure TWdMain.SpeedButton5Click(Sender: TObject);
begin
  Img_Courbe_Carthesienne(5);
end;

procedure TWdMain.SpeedButton6Click(Sender: TObject);
begin
  Img_Courbe_Carthesienne(6);
end;

procedure TWdMain.SpeedButton7Click(Sender: TObject);
begin
  Img_Courbe_Carthesienne(7);
end;

procedure TWdMain.SpeedButton8Click(Sender: TObject);
begin
  Img_Courbe_Carthesienne(8);
end;

procedure TWdMain.SpeedButton9Click(Sender: TObject);
begin
  Img_Courbe_Carthesienne(9);
end;

procedure TWdMain.SpeedButton10Click(Sender: TObject);
begin
  Img_Courbe_Carthesienne(10);
end;

procedure TWdMain.SpeedButton11Click(Sender: TObject);
begin
  Img_Courbe_Carthesienne(11);
end;

procedure TWdMain.SpeedButton12Click(Sender: TObject);
begin
  Img_Courbe_Carthesienne(12);
end;

procedure TWdMain.SpeedButton13Click(Sender: TObject);
begin
  Img_Courbe_Polaire(1);
end;

procedure TWdMain.SpeedButton14Click(Sender: TObject);
begin
  Img_Courbe_Polaire(2);
end;

procedure TWdMain.SpeedButton15Click(Sender: TObject);
begin
  Img_Courbe_Polaire(3);
end;

procedure TWdMain.SpeedButton16Click(Sender: TObject);
begin
  Img_Courbe_Polaire(4);
end;

procedure TWdMain.SpeedButton17Click(Sender: TObject);
begin
  Img_Courbe_Polaire(5);
end;

procedure TWdMain.SpeedButton18Click(Sender: TObject);
begin
  Img_Courbe_Polaire(6);
end;

procedure TWdMain.SpeedButton19Click(Sender: TObject);
begin
  Img_Courbe_Polaire(7);
end;

procedure TWdMain.SpeedButton20Click(Sender: TObject);
begin
  Img_Courbe_Polaire(8);
end;

procedure TWdMain.SpeedButton21Click(Sender: TObject);
begin
  Img_Courbe_Polaire(9);
end;

procedure TWdMain.SpeedButton22Click(Sender: TObject);
begin
  WdMain.Close;
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  //Ajout de l'unité Math dasn Uses pour Power
  WdMain.Width := 708;
  WdMain.Height := 766;
  Img_Courbe_Polaire(2);
  //Transformation carthesienne en polaire
  //Ex:x²+y²=2*x
  //x=r*cos(angle)
  //y=r*sin(angle)
  //-> r²=2*r*cos(angle) -> r=2*cos(angle)
end;

end.

